// NF Quellenumschalter
//
// Erstellt von: Marcus Pool
// 
// www.Marcus-Pool.de
//
// Version 1.00
//
// Versionshistorie
// 0.00 - 23.11.2012 Start mit der Software
// 1.00 - 08.06.2013 Erste Version

#include <main.h>
#include <avr/io.h>
#include <avr/eeprom.h>

extern uint16_t 	EE_LED_status		EEMEM;	// I2C LED Status
extern unsigned int led_array[15];

///////////////////////////////////////////////////////////////////////////////
//
//	Einschalten der gerade LEDs nach Vorgabe
//
///////////////////////////////////////////////////////////////////////////////
void LED(uint8_t LED_nr)
{
	LINE_A_dir = 0; LINE_B_dir = 0; LINE_C_dir = 0; LINE_D_dir = 0; LINE_E_dir = 0; // Alle Pins auf Eingang

	if (LED_nr == 0x00)					// LED 1 rot
	{
		LINE_A_dir = 1; LINE_C_dir = 1;
		LINE_A_out = 1; LINE_C_out = 0;
	}
	else if (LED_nr == 0x01)			// LED 1 grn
	{
		LINE_A_dir = 1; LINE_C_dir = 1;
		LINE_A_out = 0; LINE_C_out = 1;
	}
	else if (LED_nr == 0x02)			// LED 2 rot
	{
		LINE_C_dir = 1; LINE_D_dir = 1;
		LINE_C_out = 1; LINE_D_out = 0;
	}
	else if (LED_nr == 0x03)			// LED 2 grn
	{
		LINE_C_dir = 1; LINE_D_dir = 1;
		LINE_C_out = 0; LINE_D_out = 1;
	}
	else if (LED_nr == 0x04)			// LED 3 rot
	{
		LINE_B_dir = 1; LINE_C_dir = 1;
		LINE_B_out = 1; LINE_C_out = 0;
	}
	else if (LED_nr == 0x05)			// LED 3 grn
	{
		LINE_B_dir = 1; LINE_C_dir = 1;
		LINE_B_out = 0; LINE_C_out = 1;
	}
	else if (LED_nr == 0x06)			// LED 4 rot
	{
		LINE_A_dir = 1; LINE_B_dir = 1;
		LINE_A_out = 1; LINE_B_out = 0;
	}
	else if (LED_nr == 0x07)			// LED 4 grn
	{ 
		LINE_A_dir = 1; LINE_B_dir = 1;
		LINE_A_out = 0; LINE_B_out = 1;
	}
	else if (LED_nr == 0x08)			// LED 5 rot
	{
		LINE_A_dir = 1; LINE_D_dir =1;
		LINE_A_out = 1; LINE_D_out = 0;
	}
	else if (LED_nr == 0x09)			// LED 5 grn
	{
		LINE_A_dir = 1; LINE_D_dir = 1;
		LINE_A_out = 0; LINE_D_out = 1;
	}
	else if (LED_nr == 0x0A)			// LED 6 rot
	{
		LINE_D_dir = 1; LINE_E_dir = 1;
		LINE_D_out = 1; LINE_E_out = 0;
	}
	else if (LED_nr == 0x0B)			// LED 6 grn
	{
		LINE_D_dir = 1; LINE_E_dir = 1;
		LINE_D_out = 0; LINE_E_out = 1;
	}
	else if (LED_nr == 0x0C)			// LED 7 rot
	{
		LINE_A_dir = 1; LINE_E_dir = 1;
		LINE_A_out = 1; LINE_E_out = 0;
	}
	else if (LED_nr == 0x0D)			// LED 8 grn
	{
		LINE_A_dir = 1; LINE_E_dir = 1;
		LINE_A_out = 0; LINE_E_out = 1;
	}
	else
	{
		LINE_A_dir = 0; LINE_B_dir = 0; LINE_C_dir = 0; LINE_D_dir = 0; LINE_E_dir = 0; // Alle Pins auf Eingang
	}
}


///////////////////////////////////////////////////////////////////////////////
//
//	Speichern der gerade aktivierten LEDs
//
///////////////////////////////////////////////////////////////////////////////
void save_LED(void)
{
	uint16_t temp  = 0;
	uint8_t i = 0;

	for (i = 0; i <= 13; i++)
	{
		if (led_array[i] == 1)
			temp |= (1 << 0);			// Bit 0 auf 1 setzen
		temp = temp * 2;
	}
	eeprom_write_word((uint16_t*)&EE_LED_status, temp);	// LED
}

///////////////////////////////////////////////////////////////////////////////
//
//	Laden der vormals aktivierten LEDs
//
///////////////////////////////////////////////////////////////////////////////
void load_LED (void)
{
	uint16_t temp  = 0;
	uint8_t i = 0;

	temp = eeprom_read_word((uint16_t*)&EE_LED_status);	// LED
	for (i = 0; i <= 13; i++)
	{
		temp = temp / 2;
		if (temp & 0x01)
			led_array[13-i] = 1;
		else 
			led_array[13-i] = 0;
	}
}
