// NF Quellenumschalter
//
// Erstellt von: Marcus Pool
// 
// www.Marcus-Pool.de
//
// Version 1.00
//
// Versionshistorie
// 0.00 - 12.10.2012 Start mit der Software
// 1.00 - 08.06.2013 Erste Version

#include <main.h>
#include <avr/io.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include <LED.h>
#include <inttypes.h>
#include <init.h>
#include <poti.h>
#include <lcd.h>
#include <stdlib.h>
#include <inttypes.h>
#include <stdio.h>
#include <util/delay.h> 
#include <i2cmaster.h>
#include <avr/pgmspace.h>

volatile int16_t 	enc_delta=0; 	     	// +/- 32767
volatile uint16_t 	poti_counter = 0;		// nach 1 s wird die Lautstrke gespeichert
volatile uint16_t 	led_counter = 0;		// nach 1 s wird die LED gespeichert
volatile uint16_t 	AD_value = 0;			// AD Converter Wert

volatile uint8_t	Taster = 0;				// Tasterwert
volatile uint8_t	AD_count = 0;			// AD Converter Zhler
volatile uint8_t	led_multiplex = 0;		// LED Multiplex Zhler
volatile uint8_t	LED_nr = 0;				// LED Zhler
volatile uint8_t	LED_aktiv = 0;			// Speicher fr den aktuellen Ein/Ausgang
volatile int8_t		Poti_wert = 0;			// aktueller Poti Wert
volatile uint8_t	Mute = 0;				// Mute aktiviert/deaktiviert?

volatile unsigned int led_array[14] = {0,1,0,1,0,1,0,1,0,1,0,1,0,1};

volatile uint16_t	EE_LED_status	EEMEM;	// I2C LED Status

volatile uint8_t	EE_Ein1_Poti	EEMEM;	// Poti Ein 1 Wert
volatile uint8_t	EE_Ein2_Poti	EEMEM;	// Poti Ein 2 Wert
volatile uint8_t	EE_Ein3_Poti	EEMEM;	// Poti Ein 3 Wert
volatile uint8_t	EE_Ein4_Poti	EEMEM;	// Poti Ein 4 Wert
volatile uint8_t	EE_Aus1_Poti	EEMEM;	// Poti Aus 1 Wert
volatile uint8_t	EE_Aus2_Poti	EEMEM;	// Poti Aus 2 Wert
volatile uint8_t	EE_Aus3_Poti	EEMEM;	// Poti Aus 3 Wert
volatile uint8_t	EE_Mute			EEMEM;	// Mute 
volatile uint8_t	EE_Taste		EEMEM;	// letzte gedrckte Taste

volatile int8_t volume_temp = 0;			// Frequenznderung vom Drehgeber (alle 50ms)

volatile struct BitVariablen{
	int	poti_update 		:1;				// Lautstrke
	int taster_druck		:1;				// Taster gedrckt
	int taster_auswertung	:1;				// Tastendruck auswertung
	int taster_pause		:1;				// Wartezeit nach Tastendruck
	int led_update			:1;				// LED gendert
	int ledsave				:1;				// LED Speicher
	int potisave			:1;				// Potiwerte speichern
}bitvar = {0};

static   int8_t last = 0;


///////////////////////////////////////////////////////////////////////////////
//
// Auswerten des Tastendrucks
//
///////////////////////////////////////////////////////////////////////////////
void Tastendruck(uint8_t taster_in)
{
	//uint8_t adresse, command_byte = 0;

	switch (taster_in)
	{
		case 1:	lcd_puts("Ein 1   "); break;
		case 2:	lcd_puts("Ein 2   "); break;
		case 3:	lcd_puts("Ein 3   "); break;
		case 4:	lcd_puts("Ein PC  "); break;
		case 5:	lcd_puts("Aus 1   "); break;
		case 6:	lcd_puts("Aus 2   "); break;
		case 7:	lcd_puts("Aus PC  "); break;
	}
	if (Taster == taster_in)								// Taster zum Zweiten mal gedrckt
	{
		bitvar.led_update = 1;								// LED gendert
		if (led_array[(taster_in * 2) - 2] == 1)			// LED war grn. LED auf rot setzen und Poti auf 0.
		{
			poti_anzeige(0x00, taster_in);					// Mute Zeichen ausgeben
			led_array[(taster_in * 2) - 2] = 0;				// grn aus
			led_array[(taster_in * 2) - 1] = 1;				// rot an
			Poti_wert_to_I2C(0, taster_in);
		}
		else												// LED war rot, Poti einschalten
		{
			switch (taster_in)
			{
				case 1:
				Poti_wert = eeprom_read_byte((uint8_t*)&EE_Ein1_Poti);	// Poti Ein 1 Wert aus EEPROM laden, Taster 1
				break;
				case 2:
				Poti_wert = eeprom_read_byte((uint8_t*)&EE_Ein2_Poti);	// Poti Ein 2 Wert aus EEPROM laden, Taster 2
				break;
				case 3:
				Poti_wert = eeprom_read_byte((uint8_t*)&EE_Ein3_Poti);	// Poti Ein 3 Wert aus EEPROM laden, Taster 3
				break;
				case 4:
				Poti_wert = eeprom_read_byte((uint8_t*)&EE_Ein4_Poti);	// Poti Ein 4 Wert aus EEPROM laden, Taster 4
				break;
				case 5:
				Poti_wert = eeprom_read_byte((uint8_t*)&EE_Aus1_Poti);	// Poti Aus 1 Wert aus EEPROM laden, Taster 5
				break;
				case 6:
				Poti_wert = eeprom_read_byte((uint8_t*)&EE_Aus2_Poti);	// Poti Aus 2 Wert aus EEPROM laden, Taster 6
				break;
				case 7:
				Poti_wert = eeprom_read_byte((uint8_t*)&EE_Aus3_Poti);	// Poti Aus 3 Wert aus EEPROM laden, Taster 7
				break;
			}
			if (Poti_wert != 0)
			{
				led_array[(taster_in * 2) - 2] = 1;						// grn an
				led_array[(taster_in * 2) - 1] = 0;						// rot aus
				Poti_wert_to_I2C(Poti_wert, taster_in);
				poti_anzeige(Poti_wert, taster_in);
			}
			else
				poti_anzeige(0x00, taster_in);							// Mute Zeichen ausgeben
		}
	}
	else																// Taster zum ersten Mal gedrckt
	{
		eeprom_write_byte((uint8_t*)&EE_Taste, taster_in);				// letzte Taste speichern fr Neustart
		save_poti(Poti_wert, Taster);									// letzten Poti Wert speichern
		bitvar.poti_update = 0;											// nderung gespeichert
		switch (taster_in)												// alten Poti aus EEPROM laden
		{
			case 1:
			Poti_wert = eeprom_read_byte((uint8_t*)&EE_Ein1_Poti);		// Poti Ein 1 Wert aus EEPROM laden, Taster 1
			break;
			case 2:
			Poti_wert = eeprom_read_byte((uint8_t*)&EE_Ein2_Poti);		// Poti Ein 2 Wert aus EEPROM laden, Taster 2
			break;
			case 3:
			Poti_wert = eeprom_read_byte((uint8_t*)&EE_Ein3_Poti);		// Poti Ein 3 Wert aus EEPROM laden, Taster 3
			break;
			case 4:
			Poti_wert = eeprom_read_byte((uint8_t*)&EE_Ein4_Poti);		// Poti Ein 4 Wert aus EEPROM laden, Taster 4
			break;
			case 5:
			Poti_wert = eeprom_read_byte((uint8_t*)&EE_Aus1_Poti);		// Poti Aus 1 Wert aus EEPROM laden, Taster 5
			break;
			case 6:
			Poti_wert = eeprom_read_byte((uint8_t*)&EE_Aus2_Poti);		// Poti Aus 2 Wert aus EEPROM laden, Taster 6
			break;
			case 7:
			Poti_wert = eeprom_read_byte((uint8_t*)&EE_Aus3_Poti);		// Poti Aus 3 Wert aus EEPROM laden, Taster 7
			break;
		}
		if (led_array[(taster_in * 2) - 2] == 1)						// ist die LED grn?
		{
			Poti_wert_to_I2C(Poti_wert, taster_in);						// dann Wert in I2C Poti schreiben
			poti_anzeige(Poti_wert, taster_in);							// und anzeigen
		}
		else															// LED rot und Poti != 0
			poti_anzeige(0x00, taster_in);								// sonst "Mute" Zeichen anzeigen.
	}
	Taster = taster_in;													// Taster = letzten gedrckten Taster
}


///////////////////////////////////////////////////////////////////////////////
//
//	Auslesen des Encoders
//
///////////////////////////////////////////////////////////////////////////////
int16_t encoder_read(void)         			// Encoderwerte auslesen
{
	int16_t val = 0;

	cli();
	val = enc_delta;						// lade aktuellen Wert
	enc_delta = val & 1;					// Wert zurcksetzen
	sei();
	return val >> 1;
}


///////////////////////////////////////////////////////////////////////////////
//
//	Hauptprogramm
//
///////////////////////////////////////////////////////////////////////////////
int main(void)
{
	int8_t new, i;
	bitvar.poti_update = 0;
	bitvar.taster_druck = 0;
	bitvar.taster_auswertung = 0;

	// Eingnge
		DDRD &= ~(( 1 << ENC_A) | (1 << ENC_B));
		DDRC &= ~(( 1 << 0));										// AD converter Eingang
		DDRC &= ~(( 1 << 4));										// Taster vom Encoder

	// Ausgnge
		DDRD |= ((1 << 0) | (1 << 1) | (1 << 2) | (1 << 3));		// Out 1-4, 
		DDRB |= ((1 << 4) | (1 << 5));								// Line A, C
		DDRC |= ((1 << 1) | (1 << 2) | (1 << 3));					// Line B, D, E

	// Pull up an
		PORTD |= ((1 << ENC_A) | (1 << ENC_B));
		PORTD |= ((1 << 4));

		LINE_A_dir = 0; LINE_B_dir = 0; LINE_C_dir = 0; LINE_D_dir = 0; LINE_E_dir = 0; // Alle Pins auf Eingang

	// Timer 1
		TCCR1B |= (0 << WGM13) | (1 << WGM12);
		TCCR1A |= (0 << WGM11) | (0 << WGM10);
		TCCR1B |= (0 << CS12)  | (1 << CS11)  | (0 << CS10);
		TIMSK = (1 << OCIE1A);
		OCR1A = 100;												// 200 s

	// LED Charlieplexing Array
	for (i=0;i>=13;i++)
		led_array[i] = 1;

	// AD Wandler Init
		ADMUX |= ((1 << REFS0));									// Aref,internal Vref off
		ADCSRA |= ((1 << ADEN) | (1 << ADSC) | (1 << ADFR) | (1 << ADIE) | (1 << ADPS0) | (1 << ADPS1) | (1 << ADPS2));

	// Hauptencoder Initialisierung
		new = 0;
		if (PHASE_B)
			new = 3;
		if (PHASE_A)
			new ^= 1;		                   						// convert gray to binary
		last = new;                 	  							// power on state

	// Start der Initialisierung
	lcd_init(LCD_DISP_ON);											// Display on, no cursor
	Init_AVR();														// EEPROM initialieren oder Werte laden, Startscreen
	lcd_home();
	sei();															// alle Interrupts aktivieren

	// start des Hauptprogramms
	while(1)														// Schleife des Hauptprogramms
	{
		if (bitvar.ledsave == 1)									// LED Anzeigewerte speichern
		{	save_LED();												// speichere eingestellte LED
			bitvar.ledsave = 0;	
		}
		if (bitvar.potisave == 1)
		{	save_poti(Poti_wert, Taster);							// speichere eingestellte Lautstrken
			bitvar.potisave = 0;
		}

		volume_temp += encoder_read(); 								// Encoderwerte auslesen
		if ((Taster != 0) && (Mute == 0x00))						// Wert ndern nur wenn ein Poti gewhlt wurde
		{
			if (volume_temp != 0)									// Encoderwert gendert?
			{
				Poti_wert += volume_temp;							// Encoderwert zum aktuellen addieren
				if (Poti_wert >= 39)								// maximaler Wert von 39 speichern
					Poti_wert = 39;			
				if (Poti_wert <= 0)									// minimaler Wert von 0 speichern
				{
					Poti_wert = 0;
					led_array[(Taster * 2) - 2] = 0;				// grn aus
					led_array[(Taster * 2) - 1] = 1;				// rot an
					bitvar.led_update = 1;							// nderung in LED speichern
				}
				else if (Poti_wert == 1)							// Poti aktiviert
				{
					led_array[(Taster * 2) - 2] = 1;				// grn an
					led_array[(Taster * 2) - 1] = 0;				// rot aus
					bitvar.led_update = 1;							// nderung in LED speichern
				}
				else
				{
					if (led_array[(Taster * 2) - 1] == 1)			// Wenn rote LED an, dann Lautstrke nicht ndern beim ersten Drehimpuls
					{
						Poti_wert -= volume_temp;					// nderung rckgangig machen
					}
					led_array[(Taster * 2) - 2] = 1;				// grn an
					led_array[(Taster * 2) - 1] = 0;				// rot aus
				}
				volume_temp = 0;									// temp Wert lschen
				poti_anzeige(Poti_wert, Taster);					// dann Anzeige ndern und I2C neu schreiben
				Poti_wert_to_I2C(Poti_wert, Taster);
				if (bitvar.poti_update == 0)
					bitvar.poti_update = 1;							// Wert gendert und nach 1 s speichern
				else
					poti_counter = 0;								// wenn Potiwert in der letzen 1 s gendert wurde dann reset des Zhlers
			}
		}			
		else														// Mute Funktion aktiviert oder kein Taster gewhlt
		{
			volume_temp = 0;										// alle Werte vom Drehencoder lschen
		}				

		// Taster auswertung
		if ((bitvar.taster_auswertung == 1) && (Mute == 0x00))
		{
			lcd_home();
			if (bitvar.led_update == 1)								// wenn Taste in den letzen 1 s gedrckt wurde dann reset des Zhlers
				led_counter = 0;
			bitvar.taster_auswertung = 0;							// Tastendruckauswertung beendet
			if  (AD_value <= 39)									// Eingang 1
				Tastendruck(1);
			else if (AD_value <= 148)								// MUTE Taster
			{
				save_poti(Poti_wert, Taster);						// speichere eingestellte Lautstrken im EEPROM
				poti_counter = 0;									// lsche Zhler
				bitvar.poti_update = 0;								// nderung gespeichert
				Taster = 0;
				if (Mute == 0x00)									// Mute ist deaktiviert
				{
					save_LED();										// speichere eingestellte LED
					led_counter = 0;								// lsche Zhler
					bitvar.led_update = 0;							// nderung gespeichert
					for (i = 0; i <= 13; i=i+2)						// alle grnen LEDs aus
						led_array[i] = 0;
					for (i = 1; i <= 14; i=i+2)						// alle roten LEDs an
						led_array[i] = 1;
					lcd_home(); lcd_puts("Mute an ");
					potis_auf_null();								// alle Potis auf null setzen
					eeprom_write_byte((uint8_t*)&EE_Mute, 0x01);	// aktivierte Mute speichern
					Mute = 0x01;									// Mute aktiviert
				}			
			}
			else if (AD_value <= 293)								// Ausgang 3
				Tastendruck(7);
			else if (AD_value <= 440)								// Ausgang 2
				Tastendruck(6);
			else if (AD_value <= 585)								// Ausgang 1
				Tastendruck(5);
			else if (AD_value <= 722)								// Eingang 4
				Tastendruck(4);
			else if (AD_value <= 849)								// Eingang 3
				Tastendruck(3);
			else if (AD_value <= 968)								// Eingang 2
				Tastendruck(2);
		}
		else if ((bitvar.taster_auswertung == 1) && (Mute == 0x01))	// Taster gedrckt und Mute aktiviert
		{
			if (bitvar.led_update == 1)								// wenn Taste in den letzen 1 s gedrckt wurde dann reset des Zhlers
				led_counter = 0;
			bitvar.taster_auswertung = 0;							// Tastendruckauswertung beendet
			if ((AD_value >= 40) && (AD_value <= 148))
			{
				lcd_home(); 
				Taster = eeprom_read_byte((uint8_t*)&EE_Taste);		// letzte gedrckte Taste laden
				poti_werte_laden();									// Alle Poti Werte aus EEPROM laden und per I2C ausgeben
				eeprom_write_byte((uint8_t*)&EE_Mute, 0x00);		// deaktivierte Mute speichern
				Mute = 0x00;										// Mute deaktiviert
				lcd_home();
				switch (Taster)
				{
					case 1:	lcd_puts("Ein 1   "); break;
					case 2:	lcd_puts("Ein 2   "); break;
					case 3:	lcd_puts("Ein 3   "); break;
					case 4:	lcd_puts("Ein PC  "); break;
					case 5:	lcd_puts("Aus 1   "); break;
					case 6:	lcd_puts("Aus 2   "); break;
					case 7:	lcd_puts("Aus PC  "); break;
				}
				poti_anzeige(Poti_wert, Taster);
			}
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
//
//	Interrupt Routine fr den 16bit Timer
//	Alle 200 us wird die Routine aufgerufen
//
///////////////////////////////////////////////////////////////////////////////
ISR(TIMER1_COMPA_vect)           						// 200 us Interrupt
{
	uint8_t new, diff = 0;

	// LEDs multiplexen
	led_multiplex++;
	if (led_multiplex == 4)
	{
		led_multiplex = 0;
		if (led_array[LED_nr] == 1)
			LED(LED_nr);
		else
		{
			LINE_A_dir = 0; LINE_B_dir = 0; 
			LINE_C_dir = 0; LINE_D_dir = 0; 
			LINE_E_dir = 0; 							// Alle Pins auf Eingang
		}
		LED_nr++;
		if (LED_nr == 0x0E)								// Nur bis LED 14 zhlen
			LED_nr = 0;									// Dann LED Nummer auf 0 setzen
	}

	// Tasterdruck auswerten
	if ((bitvar.taster_druck == 1) && (bitvar.taster_auswertung == 0))// AD Wert kleiner als Schwelle
	{
		AD_count++;										// warte bestimmte Zeit (20 ms) bevor der AD Wert gelesen wird
		if (AD_count >= 100)
		{
			AD_count = 0;
			AD_value = ADC;								// Lese AD Wert
			bitvar.taster_druck = 0;					// 
			bitvar.taster_auswertung = 1;				// Tastendruck auswerten in main()
			bitvar.taster_pause = 1;					// Wartezeit nach Tastendruck
		}
	}
	else if ((bitvar.taster_druck == 0) && (bitvar.taster_pause == 1))
	{
		if (ADC >= 1000)
		{
			AD_count++;
			if (AD_count >= 100)
			{
				AD_count = 0;
				bitvar.taster_pause = 0;
			}
		}
	}
		
	// Hauptencoder auslesen
	new = 0;
	if	(PHASE_B)
		new = 3;
	if	(PHASE_A)
		new ^= 1;           	 					    // convert gray to binary
	diff = last - new;      							// difference last - new
	if( diff & 1 )										// bit 0 = value (1)
	{
		last = new;                 					// store new as next last
		enc_delta += (diff & 2) - 1;        			// bit 1 = direction (+/-)
	}	

	// Lautstrke speichern
	if (bitvar.poti_update == 1)						// nderung der Lautstrke
		poti_counter++;									// warte 1 s
	else 												// keine nderung
		poti_counter = 0;
	if (poti_counter >= 5000)							// alle ca. 1 s nach Lautstrkenderung Werte im EEPROM speichern
	{
		poti_counter = 0;								// lsche Zhler
		bitvar.poti_update = 0;							// nderung gespeichert
		bitvar.potisave = 1;							// Variable setzen um Wert in main() zu speichern
	}

	// LED nderung speichern
	if (bitvar.led_update == 1)							// nderung der LED
		led_counter++;									// warte 1 s
	else 												// keine nderung
		led_counter = 0;
	if (led_counter >= 5000)							// alle ca. 1 s nach LED nderung Werte im EEPROM speichern
	{
		led_counter = 0;								// lsche Zhler
		bitvar.led_update = 0;							// nderung gespeichert
		bitvar.ledsave = 1;								// Variable setzem um Wert in main() zu speichern
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//	Interrupts Routine fr den AD Converter
//	Wird nach jeder AD Wandlung aufgerufen.
//
///////////////////////////////////////////////////////////////////////////////
ISR (ADC_vect)
{
	// Wenn Wert kleiner als 968, dann ist Taste gedrckt.
	if ((ADC <= 968) && (bitvar.taster_pause == 0) && (bitvar.taster_druck == 0))
	{
		bitvar.taster_druck = 1;
	}
	ADCSRA |= (1 << ADSC);								// AD Wandlung neu starten
}


///////////////////////////////////////////////////////////////////////////////
// DEBUGGING
///////////////////////////////////////////////////////////////////////////////
//     itoa( volume_enc, Buffer, 10 ); 
//	 lcd_gotoxy(5,0);
//     lcd_puts( Buffer );		
//	 _delay_ms(250);

