// NF Quellenumschalter
//
// - Ansteuerung der Digitalen Potis
//
// Erstellt von: Marcus Pool
// 
// www.Marcus-Pool.de
//
// Version 1.0
//
// Versionshistorie
// 0.00 - 28.11.2012 Start mit der Software
// 1.00 - 08.06.2013 Erste Version

#include <main.h>
#include <avr/eeprom.h>
#include <lcd.h>
#include <util/delay.h> 
#include <stdlib.h>
#include <string.h>
#include <i2cmaster.h>
#include <LED.h>

extern uint8_t	EE_Ein1_Poti	EEMEM;	// Poti Ein 1 Wert
extern uint8_t	EE_Ein2_Poti	EEMEM;	// Poti Ein 2 Wert
extern uint8_t	EE_Ein3_Poti	EEMEM;	// Poti Ein 3 Wert
extern uint8_t	EE_Ein4_Poti	EEMEM;	// Poti Ein 4 Wert
extern uint8_t	EE_Aus1_Poti	EEMEM;	// Poti Aus 1 Wert
extern uint8_t	EE_Aus2_Poti	EEMEM;	// Poti Aus 2 Wert
extern uint8_t	EE_Aus3_Poti	EEMEM;	// Poti Aus 3 Wert

extern unsigned int led_array[15];

extern uint8_t 	Taster;
extern int8_t	Poti_wert;

///////////////////////////////////////////////////////////////////////////////
//
//	Ausgeben der Wertes ins I2C Poti. Es sind 39 Schritte mglich
//	die sich jeweils um 1 dB unterscheiden.
//
///////////////////////////////////////////////////////////////////////////////
void Poti_wert_to_I2C (uint8_t volume, uint8_t taster)
{
	uint16_t i2c_wert = 0;
	uint8_t adresse, command_byte, adresse_2, temp, i2c_bit = 0;
	switch (volume)								// Werte fr I2C Poti, Logarithmisch  mit 1 dB Schritten
	{
		case 0:
		i2c_wert = 0;
		break;
		case 1:
		i2c_wert = 1;
		break;
		case 2:
		i2c_wert = 2;
		break;
		case 3:
		i2c_wert = 3;
		break;
		case 4:
		i2c_wert = 4;
		break;
		case 5:
		i2c_wert = 5;
		break;
		case 6:
		i2c_wert = 6;
		break;
		case 7:
		i2c_wert = 7;
		break;
		case 8:
		i2c_wert = 8;
		break;
		case 9:
		i2c_wert = 9;
		break;
		case 10:
		i2c_wert = 10;
		break;
		case 11:
		i2c_wert = 11;
		break;
		case 12:
		i2c_wert = 13;
		break;
		case 13:
		i2c_wert = 14;
		break;
		case 14:
		i2c_wert = 16;
		break;
		case 15:
		i2c_wert = 18;
		break;
		case 16:
		i2c_wert = 20;
		break;
		case 17:
		i2c_wert = 23;
		break;
		case 18:
		i2c_wert = 26;
		break;
		case 19:
		i2c_wert = 29;
		break;
		case 20:
		i2c_wert = 32;
		break;
		case 21:
		i2c_wert = 36;
		break;
		case 22:
		i2c_wert = 41;
		break;
		case 23:
		i2c_wert = 46;
		break;
		case 24:
		i2c_wert = 51;
		break;
		case 25:
		i2c_wert = 57;
		break;
		case 26:
		i2c_wert = 64;
		break;
		case 27:
		i2c_wert = 72;
		break;
		case 28:
		i2c_wert = 81;
		break;
		case 29:
		i2c_wert = 91;
		break;
		case 30:
		i2c_wert = 102;
		break;
		case 31:
		i2c_wert = 114;
		break;
		case 32:
		i2c_wert = 128;
		break;
		case 33:
		i2c_wert = 144;
		break;
		case 34:
		i2c_wert = 162;
		break;
		case 35:
		i2c_wert = 181;
		break;
		case 36:
		i2c_wert = 203;
		break;
		case 37:
		i2c_wert = 228;
		break;
		case 38:
		i2c_wert = 256;
		break;
		default:
		i2c_wert = 256;
		break;
	}

	if (taster == 4)								// Eingang PC
	{
		adresse = 0x58;								// Adresse 0x2C
		command_byte = 0x00 + (i2c_wert >> 8);
		adresse_2 = 0x40;							// TCON0
		i2c_bit = 3;
	}
	else if (taster == 2)							// Eingang 2
	{
		adresse = 0x58;								// Adresse 0x2C
		command_byte = 0x70 + (i2c_wert >> 8);
		adresse_2 = 0xA0;							// TCON1
		i2c_bit = 7;
	}
	else if (taster == 1)							// Eingang 1
	{
		adresse = 0x58;								// Adresse 0x2C
		command_byte = 0x60 + (i2c_wert >> 8);
		adresse_2 = 0xA0;							// TCON1
		i2c_bit = 3;
	}
	else if (taster == 3)							// Eingang 3
	{
		adresse = 0x58;								// Adresse 0x2C
		command_byte = 0x10 + (i2c_wert >> 8);
		adresse_2 = 0x40;							// TCON0
		i2c_bit = 7;
	}
	else if (taster == 5)							// Ausgang 1
	{
		adresse = 0x5C;								// Adresse 0x2E
		command_byte = 0x70 + (i2c_wert >> 8);
		adresse_2 = 0xA0;							// TCON1
		i2c_bit = 7;
	}
	else if (taster == 6)							// Ausgang 2
	{
		adresse = 0x5C;								// Adresse 0x2E
		command_byte = 0x60 + (i2c_wert >> 8);
		adresse_2 = 0xA0;							// TCON1
		i2c_bit = 3;
	}
	else if (taster == 7)							// Ausgang 3
	{
		adresse = 0x5C;								// Adresse 0x2E
		command_byte = 0x10 + (i2c_wert >> 8);
		adresse_2 = 0x40;							// TCON0
		i2c_bit = 7;
	}
	else
		return;

	i2c_start(adresse + I2C_WRITE);					// schreibe Daten ins IC
	i2c_write(command_byte);						// Adresse im Poti
	i2c_write(i2c_wert & 0xff);						// Wert
	i2c_stop();

_delay_ms(10);	
	i2c_start(adresse+I2C_WRITE);
	i2c_write(adresse_2 + 0x0C);
	i2c_rep_start(adresse+I2C_READ);
	temp = i2c_readAck();							// die oberen 8 bit
	temp = i2c_readNak();							// die unteren 8 bit
	i2c_stop();
_delay_ms(10);
	if (volume == 0)
	{
		i2c_start(adresse + I2C_WRITE);				// schreibe Daten ins IC
		i2c_write(adresse_2);						// Adresse im Poti
		temp &= ~(1 << i2c_bit);					// Bit in temp lschen
		i2c_write(temp);							// Wert
		i2c_stop();
	}
	else
	{
		temp |= (1 << i2c_bit); 
		i2c_start(adresse + I2C_WRITE);				// schreibe Daten ins IC
		i2c_write(adresse_2);						// Adresse im Poti
		i2c_write(temp);							// Wert
		i2c_stop();
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//	Lautstrkeanzeige fr den jeweiligen Kanal
//
///////////////////////////////////////////////////////////////////////////////
void poti_anzeige(uint8_t volume, uint8_t taster)
{
	if (volume >= 0)
	{
		lcd_gotoxy(6,0);
	 	if (volume == 0)
		{
			lcd_command(0x40); 					// CG-RAM Address = 40  
			lcd_data(0x04);lcd_data(0x06);  	// Zeichen 1 fr Mute
			lcd_data(0x05);lcd_data(0x04);  
			lcd_data(0x05);lcd_data(0x0E);  
			lcd_data(0x14);lcd_data(0x00);  
			lcd_data(0x08);lcd_data(0x10);  	// Zeichen 2 fr Mute
			lcd_data(0x18);lcd_data(0x08);  
			lcd_data(0x18);lcd_data(0x00);  
			lcd_data(0x00);lcd_data(0x00);  
			lcd_command(0x80); 					// Set DD-RAM Address = 0 
			lcd_gotoxy(6,0);
			lcd_putc(0);lcd_putc(1);
		}
	 	else if (volume <= 5)
		{
			lcd_command(0x40); 					// CG-RAM Address = 40  
			lcd_data(0x00);lcd_data(0x00);  	// Zeichen 1 fr Mute
			lcd_data(0x00);lcd_data(0x00);  
			lcd_data(0x00);lcd_data(0x00);  
			lcd_data(0x00);lcd_data(0x1F);  
			lcd_command(0x80); 					// Set DD-RAM Address = 0 
			lcd_gotoxy(6,0);
			lcd_putc(0); lcd_puts(" ");
		}
		else if (volume <= 10)
		{
			lcd_command(0x48); 					// CG-RAM Address = 48
			lcd_data(0x00);lcd_data(0x00);  	// Zeichen 1 fr Mute
			lcd_data(0x00);lcd_data(0x00);  
			lcd_data(0x00);lcd_data(0x00);  
			lcd_data(0x0F);lcd_data(0x1F);  
			lcd_command(0x80); 					// Set DD-RAM Address = 0 
			lcd_gotoxy(6,0);
			lcd_putc(1); lcd_puts(" ");
		}
		else if (volume <= 15)
		{ lcd_putc(2); lcd_puts(" "); }
		else if (volume <= 20)
		{ lcd_putc(3); lcd_puts(" "); }
		else if (volume <= 25)
		{ lcd_putc(4); lcd_puts(" "); }
		else if (volume <= 30)
		{ lcd_putc(4); lcd_putc(5); }
		else if (volume <= 35)
		{ lcd_putc(4); lcd_putc(6); }
		else if (volume <= 39)
		{ lcd_putc(4); lcd_putc(7);	}
		else 
			volume = 39;						// maximal Wert
	}
}



///////////////////////////////////////////////////////////////////////////////
//
//	Aktuelle Potiwert im EEPROM speichern
//
///////////////////////////////////////////////////////////////////////////////
void save_poti(uint8_t temp, uint8_t Taster)
{
	if (Taster == 1)
		eeprom_write_byte((uint8_t*)&EE_Ein1_Poti, temp);	// Poti Ein 1 Wert zurcksetzen
	else if (Taster == 2)
		eeprom_write_byte((uint8_t*)&EE_Ein2_Poti, temp);	// Poti Ein 2 Wert zurcksetzen
	else if (Taster == 3)
		eeprom_write_byte((uint8_t*)&EE_Ein3_Poti, temp);	// Poti Ein 3 Wert zurcksetzen
	else if (Taster == 4)
		eeprom_write_byte((uint8_t*)&EE_Ein4_Poti, temp);	// Poti Ein 4 Wert zurcksetzen
	else if (Taster == 5)
		eeprom_write_byte((uint8_t*)&EE_Aus1_Poti, temp);	// Poti Aus 1 Wert zurcksetzen
	else if (Taster == 6)
		eeprom_write_byte((uint8_t*)&EE_Aus2_Poti, temp);	// Poti Aus 2 Wert zurcksetzen
	else if (Taster == 7)
		eeprom_write_byte((uint8_t*)&EE_Aus3_Poti, temp);	// Poti Aus 3 Wert zurcksetzen
}

///////////////////////////////////////////////////////////////////////////////
//
//	Alle Poti Werte auf Null setzen
//
///////////////////////////////////////////////////////////////////////////////
void potis_auf_null (void)
{
			// Eingangs IC auf minimale Lautstrke
			i2c_start(0x58 + I2C_WRITE);						// schreibe Daten ins IC
			i2c_write(0x00);									// schreibe in Poti 1, Eingang 
			i2c_write(0x00);									//
			i2c_stop();
			i2c_start(0x58 + I2C_WRITE);						// schreibe Daten ins IC
			i2c_write(0x10);									// schreibe in Poti 2, Eingang
			i2c_write(0x00);									//
			i2c_stop();
			i2c_start(0x58 + I2C_WRITE);						// schreibe Daten ins IC
			i2c_write(0x60);									// schreibe in Poti 3, Eingang
			i2c_write(0x00);									//
			i2c_stop();
			i2c_start(0x58 + I2C_WRITE);						// schreibe Daten ins IC
			i2c_write(0x70);									// schreibe in Poti 4, Eingang
			i2c_write(0x00);									//
			i2c_stop();
			// Ausgangs IC auf minimale Lautstrke
			i2c_start(0x5C + I2C_WRITE);						// schreibe Daten ins IC
			i2c_write(0x70);									// schreibe in Poti 1, Ausgang
			i2c_write(0x00);									//
			i2c_stop();
			i2c_start(0x5C + I2C_WRITE);						// schreibe Daten ins IC
			i2c_write(0x10);									// schreibe in Poti 2, Ausgang
			i2c_write(0x00);									//
			i2c_stop();
			i2c_start(0x5C + I2C_WRITE);						// schreibe Daten ins IC
			i2c_write(0x60);									// schreibe in Poti 3, Ausgang
			i2c_write(0x00);									//
			i2c_stop();	
}

///////////////////////////////////////////////////////////////////////////////
//
//	Alle Poti Werte aus EEPROM laden und per I2C ausgeben
//
///////////////////////////////////////////////////////////////////////////////
void poti_werte_laden (void)
{
	int8_t	i = 0;												// aktueller Poti Wert
	uint16_t temp  = 0;
	load_LED();													// laden der vormals aktivierten LEDs

	for (i = 1; i <= 7; i++)
	{
		if (led_array[(i * 2) - 2] == 1)			// grne LED an?
		{
			switch (i)
			{
				case 1:
				temp = eeprom_read_byte((uint8_t*)&EE_Ein1_Poti);		// Poti Ein 1 Wert aus EEPROM laden, Taster 1
				break;
				case 2:
				temp = eeprom_read_byte((uint8_t*)&EE_Ein2_Poti);		// Poti Ein 2 Wert aus EEPROM laden, Taster 2
				break;
				case 3:
				temp = eeprom_read_byte((uint8_t*)&EE_Ein3_Poti);		// Poti Ein 3 Wert aus EEPROM laden, Taster 3
				break;
				case 4:
				temp = eeprom_read_byte((uint8_t*)&EE_Ein4_Poti);		// Poti Ein 4 Wert aus EEPROM laden, Taster 4
				break;
				case 5:
				temp = eeprom_read_byte((uint8_t*)&EE_Aus1_Poti);		// Poti Aus 1 Wert aus EEPROM laden, Taster 5
				break;
				case 6:
				temp = eeprom_read_byte((uint8_t*)&EE_Aus2_Poti);		// Poti Aus 2 Wert aus EEPROM laden, Taster 6
				break;
				case 7:
				temp = eeprom_read_byte((uint8_t*)&EE_Aus3_Poti);		// Poti Aus 3 Wert aus EEPROM laden, Taster 7
				break;
			}
			Poti_wert_to_I2C(temp, i);
			if (i == Taster)
			{
				Poti_wert = temp;
			}
		}
		else
		{
			Poti_wert_to_I2C(0x00, i);
		}
	}


}